#include <bits/stdc++.h>
#define x first
#define y second
/// these defines are kinda lame, but whateva, i'm lazy
using namespace std;

int n;
const int MAXN = 2 * 1e6;
pair<int, int> pts[MAXN];

inline int pow2(int power) {
	return 1 << power;
}

int xtree[MAXN * 4];
int xheight;
int xlazy[MAXN * 4];

int xleaf(int leaf_index) {
	return pow2(xheight - 1) - 1 + leaf_index;
}

void xbuild() {
	xheight = ceil(log2(n)) + 1;

	for(int i = 0 ; i < n; ++i)
		xtree[xleaf(i)] = pts[i].y;

	for(int i =	xleaf(0) - 1; i >= 0; --i)
		xtree[i] = max(xtree[i * 2 + 1], xtree[i * 2 + 2]);
}

void xpropagate(int node) {
	xtree[node] += xlazy[node];
	if(node < xleaf(0)) {
		xlazy[node * 2 + 1] += xlazy[node];
		xlazy[node * 2 + 2] += xlazy[node];
	}
	xlazy[node] = 0;
}

void xupdate(int uleft, int uright, int u, int node, int cleft, int cright) { /// u - update; c - current
	if(uleft <= cleft && cright <= uright) {
		xlazy[node] += u;
		xpropagate(node);
		return;
	}

	if(cright < uleft || uright < cleft)
		return;

	xupdate(uleft, uright, u, node * 2 + 1, cleft, (cright + cleft) / 2);
	xupdate(uleft, uright, u, node * 2 + 2, (cright + cleft) / 2 + 1, cright);
	xtree[node] = max(xtree[node * 2 + 1], xtree[node * 2 + 2]);
}

void xupdate(int uleft, int uright, int u) {
	xupdate(uleft, uright, u, 0, 0, pow2(xheight - 1) - 1);
}

int xquery(int uleft, int uright, int node, int cleft, int cright) {
	if(uleft <= cleft && cright <= uright) {
		xpropagate(node);
		return xtree[node];
	}

	if(cright < uleft || uright < cleft)
		return 0;

	return max(xquery(uleft, uright, node * 2 + 1, cleft, (cright + cleft) / 2),
			xquery(uleft, uright, node * 2 + 2, (cright + cleft) / 2 + 1, cright) );
}

int xquery(int uleft, int uright) {
	if(uleft > uright)
		return 0;
	return xquery(uleft, uright, 0, 0, pow2(xheight - 1) - 1);
}

void xprint() {
	int curr_lvl = 0;
	int lvl = 1;
	for(int i = 0; i < xleaf(n); ++i) {
		++curr_lvl;
		cout << xtree[i] << " ";
		if(curr_lvl >= lvl) {
			cout << endl;
			curr_lvl = 0;
			lvl *= 2;
		}
	}
	cout << endl;
}


int ntree[MAXN * 4];
int nheight;
int nlazy[MAXN * 4];

int nleaf(int leaf_index) {
	return pow2(nheight - 1) - 1 + leaf_index;
}

void nbuild() {
	nheight = ceil(log2(n)) + 1;

	for(int i = 0 ; i < n; ++i)
		ntree[nleaf(i)] = pts[i].y;

	for(int i = nleaf(n); i < pow2(nheight) - 1; ++i)
		ntree[i] = numeric_limits<int>::max();

	for(int i =	nleaf(0) - 1; i >= 0; --i)
		ntree[i] = min(ntree[i * 2 + 1], ntree[i * 2 + 2]);
}

void npropagate(int node) {
	ntree[node] += nlazy[node];
	if(node < nleaf(0)) {
		nlazy[node * 2 + 1] += nlazy[node];
		nlazy[node * 2 + 2] += nlazy[node];
	}
	nlazy[node] = 0;
}

void nupdate(int uleft, int uright, int u, int node, int cleft, int cright) { /// u - update; c - current
	if(uleft <= cleft && cright <= uright) {
		nlazy[node] += u;
		npropagate(node);
		return;
	}

	if(cright < uleft || uright < cleft)
		return;

	nupdate(uleft, uright, u, node * 2 + 1, cleft, (cright + cleft) / 2);
	nupdate(uleft, uright, u, node * 2 + 2, (cright + cleft) / 2 + 1, cright);
	ntree[node] = min(ntree[node * 2 + 1], ntree[node * 2 + 2]);
}

void nupdate(int uleft, int uright, int u) {
	nupdate(uleft, uright, u, 0, 0, pow2(nheight - 1) - 1);
}

int nquery(int uleft, int uright, int node, int cleft, int cright) {
	if(uleft <= cleft && cright <= uright) {
		npropagate(node);
		return ntree[node];
	}

	if(cright < uleft || uright < cleft)
		return numeric_limits<int>::max();

	return min(nquery(uleft, uright, node * 2 + 1, cleft, (cright + cleft) / 2),
			nquery(uleft, uright, node * 2 + 2, (cright + cleft) / 2 + 1, cright) );
}

int nquery(int uleft, int uright) {
	if(uleft > uright) {
		//cout << uleft << " " << uright << endl;
		return numeric_limits<int>::max();
	}

	return nquery(uleft, uright, 0, 0, pow2(nheight - 1) - 1);
}

void nprint() {
	int curr_lvl = 0;
	int lvl = 1;
	for(int i = 0; i < nleaf(n); ++i) {
		++curr_lvl;
		cout << ntree[i] << " ";
		if(curr_lvl >= lvl) {
			cout << endl;
			curr_lvl = 0;
			lvl *= 2;
		}
	}
	cout << endl;
}


int main() {
	cin >> n;
	for(int i = 0; i < n; ++i) {
		cin >> pts[i].x >> pts[i].y;
	}

	xbuild();
	//xprint();
	nbuild();
	//nprint();


	int ans = numeric_limits<int>::max();
	for(int i = 0; i < n; ++i) {
		for(int j = i; j < n; ++j) {
			if(i == 0 && j == n - 1)
				continue;
			int x_diff = pts[j].x - pts[i].x;
			int y_diff = max(xquery(0, i - 1), xquery(j + 1, n - 1))
					- min(nquery(0, i - 1), nquery(j + 1, n - 1));
			if(ans > x_diff + y_diff)
				ans = x_diff + y_diff;
			//cout << i << " " << j << " " << x_diff << " " << y_diff << endl;
		}
	}

	cout << ans << endl;

	return 0;
}
