#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int t, n;
vector<int> a;
vector<int> heights;
vector<bool> special;

void read() {
    cin >> t;

    a.resize(t);
    for (auto &i : a) {
        cin >> i;
    }

    n = a.back();
    heights.resize(n, -1);
    special.resize(n, false);

    for (auto &i : a) {
        special[i - 1] = true;
    }

    int w;
    cin >> w;

    for (int i = 0; i < w; i++) {
        int id, w;
        cin >> id >> w;

        heights[id - 1] = w;
    }
}

int minDiff = 1e9, minSum = 1e9;

bool isSpecial(int pos) {
    if (pos == 0) {
        return heights[0] < heights[1];
    }

    if (pos == n - 1) {
        return true;
    }

    if (heights[pos - 1] < heights[pos] && heights[pos] > heights[pos + 1]) {
        return true;
    }

    if (heights[pos - 1] > heights[pos] && heights[pos] < heights[pos + 1]) {
        return true;
    }

    return false;
}

bool isValid() {
    for (int i = 0; i < n; i++) {
        if (isSpecial(i) && !special[i]) {
            return false;
        }

        if (!isSpecial(i) && special[i]) {
            return false;
        }
    }

    return true;
}

int minH = 1e9, maxH = -1e9;

void bruteForce(int pos) {
    if (maxH - minH > minDiff) {
        return;
    }

    if (pos == n) {
        if (isValid()) {
            int sum = 0;

            for (int i : a) {
                sum += heights[i - 1];
            }

            if (maxH - minH < minDiff) {
                minDiff = maxH - minH;
                minSum = sum;
            } else if (maxH - minH == minDiff) {
                minSum = min(minSum, sum);
            }
        }

        return;
    }

    if (heights[pos] != -1) {
        if (heights[pos] == heights[pos - 1]) {
            return;

        }

        int origMinH = minH, origMaxH = maxH;
        minH = min(minH, heights[pos]);
        maxH = max(maxH, heights[pos]);
        bruteForce(pos + 1);
        minH = origMinH, maxH = origMaxH;
        return;
    }

    if (pos == 0) {
        for (int i = -10; i <= 10; i++) {
            heights[0] = i;
            int origMinH = minH, origMaxH = maxH;
            minH = maxH = i;
            bruteForce(1);
            minH = origMinH, maxH = origMaxH;
        }

        heights[0] = -1;

        return;
    }

    if (pos == 1) {
        for (int i = heights[0] + 1; i <= 10; i++) {
            heights[1] = i;
            int origMinH = minH, origMaxH = maxH;
            minH = min(minH, i);
            maxH = max(maxH, i);
            bruteForce(2);
            minH = origMinH, maxH = origMaxH;
        }

        heights[1] = -1;

        return;
    }

    for (int i = -10; i <= 10; i++) {
        if (i == heights[pos - 1]) {
            continue;
        }

        heights[pos] = i;

        if (isSpecial(pos - 1) && !special[pos - 1]) {
            continue;
        }

        if (!isSpecial(pos - 1) && special[pos - 1]) {
            continue;
        }

        int origMinH = minH, origMaxH = maxH;
        minH = min(minH, i);
        maxH = max(maxH, i);

        bruteForce(pos + 1);

        minH = origMinH, maxH = origMaxH;
    }

    heights[pos] = -1;
}

void solve() {
    bruteForce(0);

    cout << minDiff << ' ' << minSum << endl;
}

int main() {
    setIO();

    read();

    solve();
}
