#include <iostream>
using namespace std;
typedef long long int i;

const i inf = (i) (((unsigned i) -1)>>1);
const i ninf = -1*inf;

class Rangetree {
    public:
    i s;
    i e;
    i split; // first index of right tree
    i maximum;
    i minimum;
    Rangetree* left;
    Rangetree* right;
    Rangetree(i si, i ei, i arr[]) {
        //cout << "constructing from " << si << " to " << ei << endl;
        if (ei < si) {cout << "ERROR WHILE CONSTRUCTING" << endl; return;}
        this->s = si;
        this->e = ei;
        if (si == ei) {
            this->maximum = this->minimum = arr[si];
        } else {
            if (ei - si <= 2) {
                this->split = si + 1;
            } else {
                this->split = ((si+ei)/2);
            }
            left = new Rangetree(si, this->split-1, arr);
            right = new Rangetree(this->split, ei, arr);
            this->maximum = max(left->maximum, right->maximum);
            this->minimum = min(left->minimum, right->minimum);
        }
    }

    i find_max(i si, i ei) {
        //cout << "finding max from " << si << " to " << ei << "with split " << this->split << endl;
        i res;
        if (si > ei) {
            res = ninf;
        } else if (this->s == si && this->e == ei) {
            res = this->maximum;
        } else {
            res = max(left->find_max(si, min(ei,(this->split)-1)), right->find_max(max(si,this->split), ei));
        }
        //cout << "max from " << si << " to " << ei << " is " << res << endl;
        return res;
    }

    i find_min(i si, i ei) {
        i res;
        if (si > ei) {
            res = inf;
        } else if (this->s == si && this->e == ei) {
            res = this->minimum;
        } else {
            res = min(left->find_min(si, min(ei,(this->split)-1)), right->find_min(max(si,this->split), ei));
        }
        //cout << "min from " << si << " to " << ei << " is " << res << endl;
        return res;
    }
};

int main() {
    // input
    i n;
    cin >> n;
    i x[n];
    i y[n];
    for (i j=0; j<n; j++) {
        cin >> x[j] >> y[j];
    }

    // construct tree for logn finding of max and min y in a given range
    // construction will take n time (and nlogn space, i think)
    //cout << "begin constructing" << endl;
    Rangetree* t = new Rangetree(0, n-1, y);
    //cout << "end constructing" << endl;

    // cout << t->find_max(0,0) << endl; return 0;

    // algo time
    i s = 0;
    i e = 0;
    i dy = t->find_max(1,n-1) - t->find_min(1,n-1);
    i dx = x[e] - x[s];
    i res = dx + dy;
    //cout << res << endl << "---" << endl;
    i minres = res;
    for (i j=1; j<n-1; j++) {
        e++;
        i dxwith = dx+1;
        i dxwithout = 0;
        i dywith = max(t->find_max(0,s-1),t->find_max(e+1,n-1)) - min(t->find_min(0,s-1),t->find_min(e+1,n-1));
        i dywithout = max(t->find_max(0,e-1),t->find_max(e+1,n-1)) - min(t->find_min(0,e-1),t->find_min(e+1,n-1));
        //cout << "max: " << max(t->find_max(0,e-1),t->find_max(e+1,n-1)) << endl;
        //cout << "min: " << min(t->find_min(0,e-1),t->find_min(e+1,n-1)) << endl;
        //cout << "dywithout: " << dywithout << endl;
        i reswithout = dxwithout + dywithout;
        //cout << reswithout << endl;
        i reswith = dxwith + dywith;
        //cout << reswith << endl;
        res = min(reswithout, reswith);
        if (reswith > reswithout) {
            s = e;
        }
        //cout << res << endl;
        //cout << "---" << endl;
        minres = min(minres, res);
    }
    // TODO - check case with only rightmost point
    cout << minres << endl;


}
