#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
template<typename T> void check_max(T &a, const T &b){ a = (a > b) ? a : b;}
template<typename T> void check_min(T &a, const T &b){ a = (a < b) ? a : b;}
const int N = 2e6 + 3;
const int INF = 5e8;

int n;
pair<int, int> p[N];
int mx_pr[N], mn_pr[N], mx_su[N], mn_su[N], t[N], f_big[N], f_small[N];
int ans = INF;

void solve(bool max_pr_su, bool min_pr_su){
    int l = 2, r = n + 1;
    for(int i = 1; i <= n; ++i)
        t[i] = p[i].first + ((!max_pr_su) ? mx_su[i + 1] : 0) - ((!min_pr_su) ? mn_su[i + 1] : 0);

    for(int i = 0; i <= n - 1; ++i){
        check_max(l, i + 2);
        for(int j = l; j <= r; ++j){
            if(i == 0 && j == n + 1) continue;
            if(i == 0 && (min_pr_su || max_pr_su)) continue;
            //cout << ans << " ans" << endl;
            //cout << i << " " << j << " - " << max_pr_su << " " << min_pr_su << endl;
             check_min(ans, t[j - 1] + (max_pr_su ? mx_pr[i] : 0) - (min_pr_su ? mn_pr[i] : 0) - p[i + 1].first);
        }

        if(max_pr_su) check_max(l, f_big[i + 1] + 1);
        else check_min(r, f_big[i + 1]);

        if(min_pr_su) check_max(l, f_small[i + 1] + 1);
        else check_min(r, f_small[i + 1]);
    }
}

void init_pr_su(){
    mx_pr[0] = -INF;
    mn_pr[0] = INF;
    for(int i = 1; i <= n; ++i){
        mx_pr[i] = max(mx_pr[i - 1], p[i].second);
        mn_pr[i] = min(mn_pr[i - 1], p[i].second);
    }

    mx_su[n + 1] = -INF;
    mn_su[n + 1] = INF;
    for(int i = n; i >= 1; --i){
        mx_su[i] = max(mx_su[i + 1], p[i].second);
        mn_su[i] = min(mn_su[i + 1], p[i].second);
    }

    int i = 1, j = n;
    while(i != n + 1 && j != 0){
        if(mx_pr[i] >= mx_su[j]){
            --j;
        }
        else{
            f_big[i] = j;
            ++i;
        }
    }
    while(i != n + 1){
        f_big[i] = 0;
        ++i;
    }

    i = 1, j = n;
    while(i != n + 1 && j != 0){
        if(mn_pr[i] <= mn_su[j]){
            --j;
        }
        else{
            f_small[i] = j;
            ++i;
        }
    }
    while(i != n + 1){
        f_small[i] = 0;
        ++i;
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 1; i <= n; ++i)
        cin >> p[i].first >> p[i].second;

    init_pr_su();

    /*for(int i = 1; i <= n; ++i){
        cout << mn_pr[i] << " " << mx_pr[i] << " " << mn_su[i] << " " << mx_su[i] << endl;
        cout << f_big[i] << " " << f_small[i] << endl;
    }*/

    for(int i = 0; i <= 1; ++i)
        for(int j = 0; j <= 1; ++j)
            solve(i, j);
    cout << ans << "\n";
}
