#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
template<typename T> void check_max(T &a, const T &b){ a = (a > b) ? a : b;}
template<typename T> void check_min(T &a, const T &b){ a = (a < b) ? a : b;}
const int N = 2e6 + 3;
const int INF = 5e8;

int n;
pair<int, int> p[N];
int mx_pr[N], mn_pr[N], mx_su[N], mn_su[N], t[N], f_big[N], f_small[N];
int ans = INF;

struct SegmentTree{
    int mn[4 * N];

    void init(int i = 0, int l = 1, int r = n){
        if(l == r){
            mn[i] = t[l];
            return;
        }

        int mid = (l + r) >> 1;
        init(2 * i + 1, l, mid);
        init(2 * i + 2, mid + 1, r);
        mn[i] = min(mn[2 * i + 1], mn[2 * i + 2]);
    }

    int query(int l2, int r2, int i = 0, int l = 1, int r = n){
        if(r2 < l || r < l2) return INT_MAX;
        if(l2 <= l && r <= r2) return mn[i];

        int mid = (l + r) >> 1;
        return min(query(l2, r2, 2 * i + 1, l, mid), query(l2, r2, 2 * i + 2, mid + 1, r));
    }
}st;

void solve(bool max_pr_su, bool min_pr_su){
    int l_mx, r_mx, l_mn, r_mn;
    for(int i = 1; i <= n; ++i)
        t[i] = p[i].first + ((!max_pr_su) ? mx_su[i + 1] : 0) - ((!min_pr_su) ? mn_su[i + 1] : 0);
    if(!max_pr_su) l_mx = 0, r_mx = n + 1;
    else l_mx = n + 1, r_mx = n + 1;
    if(!min_pr_su) l_mn = 0, r_mn = n + 1;
    else l_mn = n + 1, r_mn = n + 1;

    st.init();

    for(int i = 0; i <= n - 1; ++i){
        //check_max(l, i + 2);
            //cout << i << " - " << l_mn << " " << r_mn << " " << l_mx << " " << r_mx << endl;
        int l = max(l_mx, l_mn), r = min(r_mx, r_mn);
        if(i == 0 && r == n + 1) r = n;
        l = max(l, i + 2);
        if(l <= r){
            int x = st.query(l - 1, r - 1);
            x += (max_pr_su ? mx_pr[i] : 0) - (min_pr_su ? mn_pr[i] : 0) - p[i + 1].first;
            check_min(ans, x);
        }

        if(max_pr_su) check_min(l_mx, f_big[i + 1] + 1);
        else check_min(r_mx, f_big[i + 1]);

        if(min_pr_su) check_min(l_mn, f_small[i + 1] + 1);
        else check_min(r_mn, f_small[i + 1]);
    }
}

void init_pr_su(){
    mx_pr[0] = -INF;
    mn_pr[0] = INF;
    for(int i = 1; i <= n; ++i){
        mx_pr[i] = max(mx_pr[i - 1], p[i].second);
        mn_pr[i] = min(mn_pr[i - 1], p[i].second);
    }

    mx_su[n + 1] = -INF;
    mn_su[n + 1] = INF;
    for(int i = n; i >= 1; --i){
        mx_su[i] = max(mx_su[i + 1], p[i].second);
        mn_su[i] = min(mn_su[i + 1], p[i].second);
    }

    int i = 1, j = n;
    while(i != n + 1 && j != 0){
        if(mx_pr[i] >= mx_su[j]){
            --j;
        }
        else{
            f_big[i] = j;
            ++i;
        }
    }
    while(i != n + 1){
        f_big[i] = 0;
        ++i;
    }

    i = 1, j = n;
    while(i != n + 1 && j != 0){
        if(mn_pr[i] <= mn_su[j]){
            --j;
        }
        else{
            f_small[i] = j;
            ++i;
        }
    }
    while(i != n + 1){
        f_small[i] = 0;
        ++i;
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 1; i <= n; ++i)
        cin >> p[i].first >> p[i].second;

    init_pr_su();

    for(int i = 0; i <= 1; ++i)
        for(int j = 0; j <= 1; ++j)
            solve(i, j);

    cout << ans << "\n";
}
/*
3
3 7
6 4
8 1
*/
