#include <iostream>
using namespace std;

const int MAXN = 300005;
const int INF = 1 << 30;

int t, w, n;
int h[MAXN], vd[MAXN], hmin[MAXN], hmax[MAXN];
int global_answer = INF;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> t;
    for (int i = 1; i <= t; ++ i)
    {
        int x;
        cin >> x;
        vd[x] = 1;
        if (t == i) n = x;
    }
    for (int i = 1; i <= n; ++ i)
    {
        h[i] = INF;
    }

    cin >> w;
    for (int i = 1; i <= w; ++ i)
    {
        int x, y;
        cin >> x >> y;
        h[x] = y;
    }
}

void tryFirst()
{
    bool possible = true;

    for (int i = 0; i <= n + 1; ++ i)
    {
        hmax[i] = +INF;
        hmin[i] = -INF;
    }

    int lt = 0, cnt = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (vd[i] == 1)
        {
            cnt++;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }

    cnt++;

    for (int i = n; i >= 1; -- i)
    {
        if (vd[i] == 1)
        {
            cnt--;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }

    if (possible)
    {
        int maxhmin = -INF, minhmax = +INF;
        for (int i = 1; i <= n; ++ i)
        {
            maxhmin = max(maxhmin, hmin[i]);
            minhmax = min(minhmax, hmax[i]);


        }

        global_answer = min(global_answer, maxhmin - minhmax);
        // cout << maxhmin << ' ' << minhmax << endl;
    }
}

void trySecond()
{
    bool possible = true;

    for (int i = 0; i <= n + 1; ++ i)
    {
        hmax[i] = +INF;
        hmin[i] = -INF;
    }

    int lt = 0, cnt = 1;
    for (int i = 1; i <= n; ++ i)
    {
        if (vd[i] == 1)
        {
            cnt++;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }

    cnt++;

    for (int i = n; i >= 1; -- i)
    {
        if (vd[i] == 1)
        {
            cnt--;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }

    if (possible)
    {
        int maxhmin = -INF, minhmax = +INF;
        for (int i = 1; i <= n; ++ i)
        {
            maxhmin = max(maxhmin, hmin[i]);
            minhmax = min(minhmax, hmax[i]);


        }

        global_answer = min(global_answer, maxhmin - minhmax);
        // cout << maxhmin << ' ' << minhmax << endl;
    }
}

int main()
{
    Init();

    tryFirst();
    trySecond();

    cout << global_answer << ' ' << 0 << endl;
    return 0;
}
