#include <iostream>
using namespace std;

const long long MAXN = 300005;
const long long INF = 1ll << 50;

long long t, w, n;
long long h[MAXN], vd[MAXN], hmin[MAXN], hmax[MAXN];
long long global_answer = INF, restriction;
long long calc = INF;

pair<long long, long long> backup[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> t;
    for (long long i = 1; i <= t; ++ i)
    {
        long long x;
        cin >> x;
        vd[x] = 1;
        if (t == i) n = x;
    }
    for (long long i = 1; i <= n; ++ i)
    {
        h[i] = INF;
    }

    cin >> w;
    for (long long i = 1; i <= w; ++ i)
    {
        long long x, y;
        cin >> x >> y;
        backup[i].first = x;
        backup[i].second = y;
        h[x] = y;
    }

    long long dist = 0;
    for (long long i = 1; i <= n; ++ i)
    {
        if (vd[i] == 1) dist = 0;
        else dist++;

        restriction = max(restriction, dist + 1);
    }
}

void doagainfirst()
{
    bool possible = true;
    long long lt = 0, cnt = 0;
    for (long long i = 1; i <= n; ++ i)
    {
        if (vd[i] == 1)
        {
            cnt++;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }

    cnt++;

    for (long long i = n; i >= 1; -- i)
    {
        if (vd[i] == 1)
        {
            cnt--;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }
}

void tryFirst()
{
    bool possible = true;
    long long sum = 0;

    for (long long i = 0; i <= n + 1; ++ i)
    {
        hmax[i] = +INF;
        hmin[i] = -INF;
    }

    long long lt = 0, cnt = 0;
    for (long long i = 1; i <= n; ++ i)
    {
        if (vd[i] == 1)
        {
            cnt++;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }

    cnt++;

    for (long long i = n; i >= 1; -- i)
    {
        if (vd[i] == 1)
        {
            cnt--;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }

    if (possible)
    {
        long long maxhmin = -INF, minhmax = +INF;
        for (long long i = 1; i <= n; ++ i)
        {
            maxhmin = max(maxhmin, hmin[i]);
            minhmax = min(minhmax, hmax[i]);
        }

        int cnt = 0;
        for (int i = 1; i <= n; ++ i)
        {
            if (vd[i] == 1)
            {
                cnt++;
                if (cnt % 2 == 0)
                {
                    //cout << i << ' ' << "isbot" << endl;
                    if (hmin[i] < maxhmin) h[i] = minhmax;
                    else h[i] = hmin[i];
                }
            }
        }

        doagainfirst();

        for (int i = 1; i <= n; ++ i)
        {
            // cout << hmin[i] << ' ' << hmax[i] << endl;
            if (vd[i] == 1) sum += hmin[i];
        }

        if (global_answer >= maxhmin - minhmax)
        {
            global_answer = min(global_answer, maxhmin - minhmax);
            calc = min(calc, sum);
        }
        // cout << maxhmin << ' ' << minhmax << endl;
    }
}

void doagainsecond()
{
    bool possible = true;
    long long lt = 0, cnt = 1;
    for (long long i = 1; i <= n; ++ i)
    {
        if (vd[i] == 1)
        {
            cnt++;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }

    cnt++;

    for (long long i = n; i >= 1; -- i)
    {
        if (vd[i] == 1)
        {
            cnt--;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }
}

void trySecond()
{
    bool possible = true;
    long long sum = 0;

    for (long long i = 0; i <= n + 1; ++ i)
    {
        hmax[i] = +INF;
        hmin[i] = -INF;
    }

    long long lt = 0, cnt = 1;
    for (long long i = 1; i <= n; ++ i)
    {
        if (vd[i] == 1)
        {
            cnt++;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i - 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i - 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }

    cnt++;

    for (long long i = n; i >= 1; -- i)
    {
        if (vd[i] == 1)
        {
            cnt--;
            lt = cnt % 2;

            if (lt == 1) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);
            if (lt == 0) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);

            if (h[i] != INF)
            {
                if (h[i] > hmax[i] or h[i] < hmin[i])
                {
                    possible = false;
                    break;
                }
                hmin[i] = hmax[i] = h[i];
            }
            continue;
        }

        if (lt == 1) hmax[i] = min(hmax[i + 1] - 1, hmax[i]);
        if (lt == 0) hmin[i] = max(hmin[i + 1] + 1, hmin[i]);

        if (h[i] != INF)
        {
            if (h[i] > hmax[i] or h[i] < hmin[i])
            {
                possible = false;
                break;
            }
            hmin[i] = hmax[i] = h[i];
        }
    }

    if (possible)
    {
        long long maxhmin = -INF, minhmax = +INF;
        for (long long i = 1; i <= n; ++ i)
        {
            maxhmin = max(maxhmin, hmin[i]);
            minhmax = min(minhmax, hmax[i]);

            // cout << hmin[i] << ' ' << hmax[i] << endl;
        }

        int cnt = 1;
        for (int i = 1; i <= n; ++ i)
        {
            if (vd[i] == 1)
            {
                cnt++;
                if (cnt % 2 == 0)
                {
                    if (hmin[i] < maxhmin) h[i] = minhmax;
                    else h[i] = hmin[i];
                }
            }
        }

        doagainsecond();

        for (int i = 1; i <= n; ++ i)
        {
            if (vd[i] == 1) sum += hmin[i];
        }

        if (global_answer >= maxhmin - minhmax)
        {
            global_answer = min(global_answer, maxhmin - minhmax);
            calc = min(calc, sum);
        }
        // cout << maxhmin << ' ' << minhmax << endl;
    }
}

signed main()
{
    Init();

    tryFirst();

    for (long long i = 1; i <= n; ++ i)
    {
        h[i] = INF;
    }
    for (long long i = 1; i <= w; ++ i)
    {
        h[backup[i].first] = backup[i].second;
    }


    trySecond();
    global_answer = max(global_answer, restriction);

    cout << global_answer << ' ' << calc << endl;
    return 0;
}
