#include<iostream>
#include<cstdio>
using namespace std;

struct point
{
	int x,y;
};

struct segment
{
	int from, to;
	int val_min, val_max;
	segment *l, *r;
	segment()
	{
		this->l = this->r = NULL;
		val_min = val_max = 0;
	}
}*root;

int n;
point p[30000];

void build(int from, int to, segment *t)
{
	t->from = from;
	t->to = to;
	
	if(from == to)
	{
		t->val_max = t->val_min = p[from].y;
		return;
	}
	t->l = new segment();
	build(from, (from+to)/2, t->l);
	
	t->r = new segment();
	build(( from+to)/2 + 1, to, t->r);
	
	t->val_min = min(t->l->val_min, t->r->val_min);
	
	t->val_max = max(t->l->val_max, t->r->val_max);
}

pair<int,int> search(int from, int to, segment *t)
{
	if(t->to < from || t->from > to) make_pair(1e9,-1);
	else if(from <= t->from && t->to <= to) return make_pair(t->val_min, t->val_max);
	else
	{
		if(t->l != NULL)
		{
			pair<int, int> f = search(from, to, t->l);
			pair<int, int> f1 = search(from,to, t->r);
			return make_pair(min(f.first, f1.first), max(f.second,f1.second));
		}
	}
}

void search_alice()
{
	int sol = -1, cur_sol = 0;
	for(int l = 0; l < n-1; l++)
	{
		for(int r = l+1; r < n; r++)
		{
			if(l == 0 && r == n-1) continue;
			
			pair<int, int> op,op2;
			op.first = op2.first = 1e9;
			op2.first = op.second = -1;
			
			if(l > 0) op = search(0,l-1,root);//before
			if(r < n-1) op2 = search(r+1,n-1,root);///after
			
			//printf("l = %d r = %d\n",l,r);
			//printf("op2.first = %d op2.second = %d\n",op2.first, op2.second);
			//printf("op.first = %d op.second = %d\n",op.first,op.second);
			
			if(op2.first == 1e9 && op.first == op.second) cur_sol = op.first;
			else if(op.first == 1e9 && op2.first == op2.second) cur_sol = op.first;
			else cur_sol = max(op.second,op2.second) - min(op.first,op2.first);
			cur_sol = cur_sol + p[r].x - p[l].x;
			
			if(sol == -1) 
			{
				sol = cur_sol;
			}
			else sol = min(sol, cur_sol); 
			//printf("sol = %d\n",sol);
		}
	}
	pair<int, int> opp,opp1;
	opp1.first = 1e9;
	opp1.second = -1;
	for(int i = 0; i < n; i++)
	{
		if(i != n-1) opp = search(i+1,n-1,root);
		if(i != 0) opp1 = search(0,i-1,root);
		cur_sol = p[i].x + (max(opp.second,opp1.second) - min(opp.first,opp1.first));
		//printf("opp.first = %d opp.second = %d\n",opp.first, opp.second);
		//printf("opp1.first = %d opp1.second = %d\n",opp1.first,opp1.second);
		sol = min(cur_sol,sol);
		//printf("sol = %d\n",sol);
	}
	printf("%d\n",sol);
}

int main()
{
	scanf("%d",&n);
	for(int i = 0; i < n; i++)
	{
		scanf("%d%d",&p[i].x,&p[i].y);
	}
	if(n == 2)
	{
		int a = p[0].x + p[1].y;
		int b = p[0].y + p[1].x;
		printf("%d\n",min(a,b));
	}
	else
	{
		root = new segment();
		build(0,n-1,root);
		search_alice();
	}
	
}
/*
3
1 28
5 24
11 14

2 
1 28
5 24
*/
