#include<iostream>
#include<cstdio>
#include<algorithm>
using namespace std;

struct segment
{
	int from, to;
	int val_min, val_max;
	segment *l, *r;
	segment()
	{
		this->l = this->r = NULL;
		this->val_min = this->val_max = 0;
	}
}*root;

struct point
{
	int x,y;
};

int n;
point p[300000];

int mod(int a, int b)
{
	return max(a,b) - min(a,b);
}

void build(int from, int to, segment *t)
{
	t->from = from;
	t->to = to;
	
	if(from == to)
	{
		t->val_max = t->val_min = p[from].y;
		return;
	}
	t->l = new segment();
	build(from, (from+to)/2, t->l);
	
	t->r = new segment();
	build(( from+to)/2 + 1, to, t->r);
	
	t->val_min = min(t->l->val_min, t->r->val_min);
	
	t->val_max = max(t->l->val_max, t->r->val_max);
}

pair<int,int> search(int from, int to, segment *t)
{
	if(t->to < from || t->from > to) make_pair(1e9,-1);
	else if(from <= t->from && t->to <= to) return make_pair(t->val_min, t->val_max);
	else
	{
		if(t->l != NULL)
		{
			pair<int, int> f = search(from, to, t->l);
			pair<int, int> f1 = search(from,to, t->r);
			
			return make_pair(min(f.first, f1.first), max(f.second,f1.second));
		}
		else return make_pair(1e9,-1);
	}
}

int main()
{
	scanf("%d",&n);
	for(int i = 0; i < n; i++)
	{
		scanf("%d%d",&p[i].x,&p[i].y);
	}
	if(n == 2)
	{
		int a = p[0].x + p[1].y;
		int b = p[0].y + p[1].x;
		printf("%d\n",min(a,b));
	}
	else
	{
		root = new segment();
		build(0,n-1,root);
		int cur_sol = 0, sol = -1;
		
		//corner cases
		int opt = min(p[n-1].y, mod(p[n-1].y, p[n-3].y) );
		int opt2 = min(p[0].y, mod(p[2].y, p[0].y));
		
		for(int i = n-4; i > 0; i--) 
		{
			opt = min(opt,mod(p[n-1].y, p[i].y) );
		}
		for(int i = 4; i < n-1; i++)
		{
			opt2 = min(opt2, mod(p[i].y,p[0].y) );
		}
		//printf("opt = %d\n",opt);
		
		//alice
		for(int l = 0; l < n; l++)
		{
			for(int r = l; r < n; r++)
			{
				pair<int, int> op, op2;
				
				op.first = op2.first = 1e9;
				op.second = op.second = -1;
				
				if(l == 0 && r == n-1) continue;
				
				if( l==r ) cur_sol = p[l].x;
				else
				{
					cur_sol = p[r].x - p[l].x;	
				}
				//printf("l = %d r=%d\n",l,r);
				//printf("cur_sol = %d\n",cur_sol);
				
				if(l > 0) op = search(0,l-1,root);
				if(r < n-1) op2 = search(r+1,n-1,root);
				
				if(r == n-2 && l == 0) 
				{
					op2 = make_pair(0,opt);
					op = make_pair(0,0);
				}
				if(l == 1 && r == n-1) 
				{
					op = make_pair(0,0);
					op2 = make_pair(0,opt2);
				}
				
				cur_sol += (max(op.second,op2.second) - min(op.first,op2.first));
				
				//printf("op2.first = %d op2.second = %d\n",op2.first, op2.second);
				//printf("op.first = %d op.second = %d\n",op.first,op.second);
				//printf("cur_sol = %d\n",cur_sol);
				
				if(sol == -1) sol = cur_sol;
				else sol = min(sol, cur_sol);
			}
		}
		printf("%d\n",sol);
	}
}
/*
4
1 28
5 24
11 14
13 30
*/

