#include<bits/stdc++.h>
#pragma optimize GCC ofast
using ll = long long;
using namespace std;

const ll MAXN = 2000002;
const ll DUMMYCODE = 100000004LL;
struct value {
    ll miny, maxy;
};

value arr[4*MAXN];
vector<pair<ll,ll>> input;

void pull(int v) {
    arr[v].miny = min(arr[2*v].miny, arr[2*v+1].miny);
    arr[v].maxy = max(arr[2*v].maxy, arr[2*v+1].maxy);
}

void build(int v, int l, int r) {
    if(l == r) {
        arr[v].miny = arr[v].maxy = input[l].second;
        return;
    }
    int mid = (l + r)/2;
    build(2*v,l, mid);
    build(2*v+1,mid+1, r);
    pull(v);
}

pair<ll,ll> mergePairs(pair<ll,ll> a, pair<ll,ll> b) {
    if(a.first == DUMMYCODE)
        return b;
    if(b.first == DUMMYCODE)
        return a;
    return {min(a.first, b.first),max(a.second, b.second)};
}
map<pair<int,int>,pair<int,int>> memo;

pair<ll,ll> query(int v, int tl, int tr, int l, int r) {
    if(l > r) {
        return {DUMMYCODE, DUMMYCODE};
    }
    if(tl > r or tr < l) {
        return {DUMMYCODE, DUMMYCODE};
    }
    if(l <= tl and tr <= r) {
        return {arr[v].miny, arr[v].maxy};
    }
    int mid = (tl+tr)/2;
    return mergePairs(query(2*v, tl, mid, l , r), query(2*v+1,mid+1, tr, l, r));
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int n;
    cin>>n;
    ll u,v;
    for(int i = 0; i < n; i++) {
        cin>>u>>v;
        input.emplace_back(u + 1,v + 1);
    }
    build(1, 0, n-1);
    vector<int> interesting;
    vector<pair<pair<ll,ll>,pair<ll,ll>>> resint;
    interesting.push_back(0);
    resint.emplace_back(query(1, 0, n-1, 0, -1), query(1, 0, n-1, 1, n-1));
    for(int i = 1; i < n - 1; i++) {
        if(input[i].first != input[i-1].first or input[i].first != input[i+1].first) {
            interesting.push_back(i);
            resint.emplace_back(query(1, 0, n-1, 0, i-1), query(1, 0, n-1, i+1, n-1));
        }
    }
    interesting.push_back(n-1);
    resint.emplace_back(query(1, 0, n-1, 0, n-2), query(1, 0, n-1, n, n-1));
    ll res = DUMMYCODE;
    for(int p1 = 0; p1 < interesting.size(); p1++) {
        for(int p2 = p1; p2 < interesting.size(); p2++) {
            if(p1 == 0 and p2 == interesting.size()-1) {continue;}
            ll dx = input[interesting[p2]].first - input[interesting[p1]].first;
            auto yres = mergePairs(resint[p1].first,
                                   resint[p2].second);
            ll dy = yres.second - yres.first;
            if(dx + dy < res) {
                res = dx + dy;
            }
        }
    }
    cout<<res<<endl;

}
