#include<iostream>
#include<cstdio>
#include<algorithm>
#include<vector>
#include<climits>
using namespace std;

int n;
vector<pair<int, int> > points;

vector<int> leftMaxY, rightMaxY;
vector<int> leftMinY, rightMinY;

int main ()
{
    scanf("%d", &n);
    for (int i=0; i<n; i++)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        points.emplace_back(a, b);
    }

    leftMaxY.resize(n);
    leftMinY.resize(n);
    rightMaxY.resize(n);
    rightMinY.resize(n);

    leftMaxY[0] = points[0].second;
    leftMinY[0] = points[0].second;
    rightMaxY[n-1] = points[n-1].second;
    rightMinY[n-1] = points[n-1].second;

    for (int i=1; i<n; i++)
    {
        leftMaxY[i] = max(leftMaxY[i-1], points[i].second);
        leftMinY[i] = min(leftMinY[i-1], points[i].second);
    }

    for (int i=n-2; i>=0; i--)
    {
        rightMaxY[i] = max(rightMaxY[i+1], points[i].second);
        rightMinY[i] = min(rightMinY[i+1], points[i].second);
    }

    int ans = INT_MAX;
    for (int i=0; i<n; i++)
    {
        for (int j=i; j<n; j++)
        {
            int candidate = 0;

            int la, li, ra, ri;
            if (i == 0)
            {
                la = INT_MIN;
                li = INT_MAX;
            }
            else
            {
                la = leftMaxY[i-1];
                li = leftMinY[i-1];
            }

            if (j == n-1)
            {
                ra = INT_MIN;
                ri = INT_MAX;
            }
            else
            {
                ra = rightMaxY[j+1];
                ri = rightMinY[j+1];
            }

            if (j - i + 1 == n) continue;

            candidate = max(la, ra) - min(li, ri) + points[j].first - points[i].first;

            ans = min(ans, candidate);
            if (la >= ra) break;
            if (li <= ri) break;
        }
    }

    cout<<ans<<endl;
}
