#include<iostream>
#include<cstdio>
#include<algorithm>
#include<vector>
#include<set>
#include<climits>
using namespace std;

int t, w, n;
vector<int> extremes;
set<int> extremesSet;

int knownMin=INT_MAX, knownMax = INT_MIN;


struct Point
{
    int min, max;

    Point()
    {
        min = INT_MIN;
        max = INT_MAX;
    }
    Point(int min, int max)
    {
        this->min = min;
        this->max = max;
    }
};

vector<Point> points;

int main ()
{
    scanf("%d", &t);
    for (int i=0; i<t; i++)
    {
        int a;
        scanf("%d", &a);
        extremes.push_back(a);
        extremesSet.insert(a);

        if (i == t-1) n = a;
    }

    points.resize(n+1);

    scanf("%d", &w);
    for (int i=0; i<w; i++)
    {
        int a, b;
        scanf("%d%d", &a, &b);

        points[a] = Point(b, b);

        knownMax = max(knownMax, b);
        knownMin = min(knownMin, b);

        int k;
        for (k=a-1; k>=1 && extremesSet.count(i) == 0; k--);

        if (k != 0)
        {
            points[k].max = min(points[k].max, b - (a-k));
            knownMin = min(knownMin, points[k].max);
        }

        for (k=a+1; k<=n && extremesSet.count(k) == 0; k++);

        if (k != n+1)
        {
            points[k].min = max(points[k].min, b + (k-a));
            knownMax = max(knownMax, points[k].min);
        }
    }

    int denivelation = 0;

    for (int i=1; i<extremes.size(); i++)
    {
        denivelation = max(denivelation, extremes[i] - extremes[i-1]);
    }

//    int lastInstance = -1;
//    bool sign = false;
//
//    for (int i=0; i<extremes.size(); i++)
//    {
//        if (points[extremes[i]].max != INT_MAX && points[extremes[i]].min != INT_MIN)
//        {
//            bool oddity = false;
//            if (i%2 == 1) oddity = true;
//
//            if (sign != oddity && lastInstance != -1)
//            {
//                if (oddity)
//                {
//                    denivelation = max(denivelation, points[extremes[i]].min - points[extremes[lastInstance]].max);
//                }
//                else
//                {
//                    denivelation = max(denivelation, points[extremes[i]].max - points[extremes[lastInstance]].min);
//                }
//            }
//
//            lastInstance = i;
//            sign = oddity;
//        }
//    }

    int biggestMin = INT_MIN, smallestMax = INT_MAX;
    for (int i=0; i<points.size(); i++)
    {
        biggestMin = max(biggestMin, points[i].min);
        smallestMax = min(smallestMax, points[i].max);
    }

    denivelation = max(denivelation, biggestMin - smallestMax);

//    cout<<knownMin<<" "<<knownMax<<endl;
//    for (int i=1; i<points.size(); i++)
//    {
//        cout<<i<<": "<<points[i].min<<" "<<points[i].max<<endl;
//    }

    cout<<denivelation<<" 0"<<endl;
}
