#include<iostream>

#define endl '\n'

using namespace std;

const int MAXN = 3e5 + 3, INF = 1e9 + 3;
int height[MAXN];
bool is_pick[MAXN];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    int n = 0;
    for (int i = 0; i < t; ++i) {
        int pick;
        cin >> pick;
        --pick;

        is_pick[pick] = true;
        n = pick;
    }

    for (int i = 0; i < n; ++i) {
        height[i] = INF;
    }

    int w;
    cin >> w;

    for (int i = 0; i < w; ++i) {
        int pos, curr_height;
        cin >> pos >> curr_height;
        if (i == 0 and pos != 1) {
            height[0] = curr_height - i;
        }
        height[pos - 1] = curr_height;
    }

    int direction = 0, last_pick = 0;
    for (int i = 1; i < n; ++i) {
        if (height[i] == INF) {
            height[i] = height[i-1] + (direction == 0 ? 1 : -1);
        } else {
            int distance = i - last_pick;
            if (direction == 0 and height[i] - distance < height[last_pick]) {
                height[last_pick] = height[i] - distance;
            } else if (direction == 1 and height[i] + distance > height[last_pick]){
                height[last_pick] = height[i] + distance;
            }
        }

        if (is_pick[i]) {
            last_pick = i;
            direction ^= 1;
        }
    }

    int max_height = height[0], min_height = height[0];
    long long sum = 1ll * height[0];

    for (int i = 1; i < n; ++i) {
        if (!is_pick[i]) {
            continue;
        }

        max_height = max(max_height, height[i]);
        min_height = min(min_height, height[i]);
        sum += 1ll * height[i];
    }

    cout << max_height - min_height << " " << sum << endl;
return 0;
}
