#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

struct point
{
    long long x;
    long long y;
};

const int MAXN=1e5;
const long long MAX_SUM=1e15;

long long minSum=MAX_SUM;
point points[MAXN];

bool CompareByX(point a, point b)
{
    return a.x<b.x;
}

bool CompareByY(point a, point b)
{
    return a.y<b.y;
}

void GetMinSum(int n, int index, vector<bool> area)
{
    if(index==n)
    {
        vector<point> a;
        vector<point> b;
        for(int i=0; i<n; i++)
        {
            if(area[i])
            {
                a.push_back(points[i]);
            }
            else
            {
                b.push_back(points[i]);
            }
        }

        if(a.size()==0 || b.size()==0)
        {
            return;
        }

        sort(a.begin(), a.end(), CompareByX);
        sort(b.begin(), b.end(), CompareByY);

        minSum=min(minSum, (a[a.size()-1].x-a[0].x)+(b[b.size()-1].y-b[0].y));

        return;
    }

    area[index]=true;
    GetMinSum(n, index+1, area);

    area[index]=false;
    GetMinSum(n, index+1, area);

    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;

    for(int i=0; i<n; i++)
    {
        cin >> points[i].x >> points[i].y;
    }

    vector<bool> area;
    area.resize(n);

    GetMinSum(n, 0, area);

    cout << minSum << "\n";

    return 0;
}

/*
5
1 1
1 20
3 3
5 5
23 4
*/
