#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

struct point
{
    long long x;
    long long y;
};

const int MAXN=1e5, MAX_HEIGHT=1e8;
const long long MAX_SUM=1e15;

long long minSum=MAX_SUM;
point points[MAXN];

long long highestBefore[MAXN];
long long lowestBefore[MAXN];

long long highestAfter[MAXN];
long long lowestAfter[MAXN];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;

    highestBefore[0]=0;
    lowestBefore[0]=MAX_HEIGHT;
    highestAfter[n-1]=0;
    lowestAfter[n-1]=MAX_HEIGHT;

    for(int i=0; i<n; i++)
    {
        cin >> points[i].x >> points[i].y;

        if(i>0)
        {
            highestBefore[i]=max(highestBefore[i-1], points[i-1].y);
            lowestBefore[i]=min(lowestBefore[i-1], points[i-1].y);
        }
    }

    for(int i=n-2; i>=0; i--)
    {
        highestAfter[i]=max(highestAfter[i+1], points[i+1].y);
        lowestAfter[i]=min(lowestAfter[i+1], points[i+1].y);
    }

    for(int i=0; i<n; i++)
    {
        if(i>0 && points[i].y>=lowestBefore[i-1] && points[i].y<=highestBefore[i-1])
        {
            continue;
        }

        for(int j=n-1; j>=i; j--)
        {
            if(i==0 && j==n-1)
            {
                continue;
            }

            long long highest=max(highestBefore[i], highestAfter[j]), lowest=min(lowestBefore[i], lowestAfter[j]);

            minSum=min(minSum, (points[j].x-points[i].x)+(highest-lowest));
        }
    }


    cout << minSum << "\n";

    return 0;
}

/*
5
1 1
1 20
3 3
5 5
23 4
*/
