#include<iostream>
#include<algorithm>
using namespace std;

const int mnogo = 100000001;

struct DanniZaTochka{
    int x;
    int y;
    int originalenIndex;
};

int broiTochki;
DanniZaTochka tochkiGoren[2000010];
DanniZaTochka tochkiDolen[2000010];

bool izpolzvanaLiETazi[2000010];

int sledvashtIndexGoren(int segashenIdx){
    int koiE = segashenIdx + 1;
    while(koiE < broiTochki){
        if(izpolzvanaLiETazi[tochkiGoren[koiE].originalenIndex] == false){
            break;
        }
        koiE++;
    }

    return koiE;
}

int predenIndexGoren(int segashenIdx){
    int koiE = segashenIdx - 1;
    while(koiE > -1){
        if(izpolzvanaLiETazi[tochkiGoren[koiE].originalenIndex] == false){
            break;
        }
        koiE--;
    }

    return koiE;
}

int sledvashtIndexDolen(int segashenIdx){
    int koiE = segashenIdx + 1;
    while(koiE < broiTochki){
        if(izpolzvanaLiETazi[tochkiDolen[koiE].originalenIndex] == false){
            break;
        }
        koiE++;
    }

    return koiE;
}

int predenIndexDolen(int segashenIdx){
    int koiE = segashenIdx - 1;
    while(koiE > -1){
        if(izpolzvanaLiETazi[tochkiDolen[koiE].originalenIndex] == false){
            break;
        }
        koiE--;
    }

    return koiE;
}

bool koqEPOMalka(DanniZaTochka a, DanniZaTochka b){
    if(a.y < b.y){
        return true;
    }
    if(a.y > b.y){
        return false;
    }
    return a.x < b.x;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>broiTochki;

    for(int i = 0; i < broiTochki; i++){
        cin>>tochkiGoren[i].x>>tochkiGoren[i].y;
        tochkiGoren[i].originalenIndex = i;
        tochkiDolen[i] = tochkiGoren[i];
    }

    sort(tochkiDolen, tochkiDolen + broiTochki, koqEPOMalka);

    int gorenLqvIdx = 0;
    int gorenDesenIdx = broiTochki - 1;
    int dolenLqvIdx = 0;
    int dolenDesenIdx = broiTochki - 1;

    int naiMalakGoren = mnogo;
    int naiGolqmGoren = 0;
    int naiMalakDolen = mnogo;
    int naiGolqmDolen = 0;

    while(gorenLqvIdx <= gorenDesenIdx && dolenLqvIdx <= dolenDesenIdx){
        //cout<<gorenLqvIdx<<" "<<gorenDesenIdx<<"  "<<dolenLqvIdx<<" "<<dolenDesenIdx<<endl;
        //cout<<naiMalakGoren<<" "<<naiGolqmGoren<<"  "<<naiMalakDolen<<" "<<naiGolqmDolen<<endl<<endl;

        int potencialenGorenMalak = min(naiMalakGoren, tochkiGoren[gorenLqvIdx].x);
        int potencialenGorenGolqm = max(naiGolqmGoren, tochkiGoren[gorenDesenIdx].x);
        int potencialenDolenMalak = min(naiMalakDolen, min(tochkiGoren[gorenLqvIdx].y, tochkiGoren[gorenDesenIdx].y));
        int potencialenDolenGolqm = max(naiGolqmDolen, max(tochkiGoren[gorenDesenIdx].y, tochkiGoren[gorenLqvIdx].y));

        if(potencialenGorenGolqm - potencialenGorenMalak <= potencialenDolenGolqm - potencialenDolenMalak){
            naiGolqmGoren = potencialenGorenGolqm;
            naiMalakGoren = potencialenGorenMalak;
        }else{
            naiMalakDolen = potencialenDolenMalak;
            naiGolqmDolen = potencialenDolenGolqm;
        }

        izpolzvanaLiETazi[tochkiGoren[gorenLqvIdx].originalenIndex] = true;
        izpolzvanaLiETazi[tochkiGoren[gorenDesenIdx].originalenIndex] = true;

        potencialenGorenMalak = min(naiMalakGoren, min(tochkiDolen[dolenLqvIdx].x, tochkiDolen[dolenDesenIdx].x));
        potencialenGorenGolqm = max(naiGolqmGoren, max(tochkiDolen[dolenDesenIdx].x, tochkiDolen[dolenLqvIdx].x));
        potencialenDolenMalak = min(naiMalakDolen, tochkiDolen[dolenLqvIdx].y);
        potencialenDolenGolqm = max(naiGolqmDolen, tochkiDolen[dolenDesenIdx].y);

        if(potencialenGorenGolqm - potencialenGorenMalak <= potencialenDolenGolqm - potencialenDolenMalak){
            naiGolqmGoren = potencialenGorenGolqm;
            naiMalakGoren = potencialenGorenMalak;
        }else{
            naiMalakDolen = potencialenDolenMalak;
            naiGolqmDolen = potencialenDolenGolqm;
        }

        izpolzvanaLiETazi[tochkiDolen[dolenLqvIdx].originalenIndex] = true;
        izpolzvanaLiETazi[tochkiDolen[dolenDesenIdx].originalenIndex] = true;

        gorenLqvIdx = sledvashtIndexGoren(gorenLqvIdx);
        gorenDesenIdx = predenIndexGoren(gorenDesenIdx);
        dolenLqvIdx = sledvashtIndexDolen(dolenLqvIdx);
        dolenDesenIdx = predenIndexDolen(dolenDesenIdx);
    }

    //cout<<gorenLqvIdx<<" "<<gorenDesenIdx<<"  "<<dolenLqvIdx<<" "<<dolenDesenIdx<<endl;
    //cout<<naiMalakGoren<<" "<<naiGolqmGoren<<"  "<<naiMalakDolen<<" "<<naiGolqmDolen<<endl<<endl;

    int otgovor = (naiGolqmGoren - naiMalakGoren) + (naiGolqmDolen - naiMalakDolen);

    cout<<otgovor<<endl;

    return 0;
}
